
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>《中国人工智能学会通讯》——8.43 基于缺陷标注挖掘软件缺陷 / iVAN</title>

    <meta name="description" content="《中国人工智能学会通讯》——8.43 基于缺陷标注挖掘软件缺陷 8.43 基于缺陷标注挖掘软件缺陷 除通过描述程序的正常模式以发现软件缺陷外,另一类有效的软件缺陷挖掘技术则是通过直接对带有人工缺陷标注的程序模块进行学习建模,建立从程序模块的特征表示到软件缺陷的映射关系,以预测给定程序模块的是否可能包含缺陷. 基于缺陷标注挖掘软件缺陷的一般流程如图 1所示.首先人工对软件源代码进行详细软件测试,获得每个模块的缺陷情况标注.然后,利用软件度量 (software metric) [8] 技术提取多种与软件模块的缺陷相关的代码级统计指标 ( 如代码长度.代码分支数">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">《中国人工智能学会通讯》——8.43 基于缺陷标注挖掘软件缺陷</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<h3>8.43 基于缺陷标注挖掘软件缺陷</h3>
<p>除通过描述程序的正常模式以发现软件缺陷外，另一类有效的软件缺陷挖掘技术则是通过直接对带有人工缺陷标注的程序模块进行学习建模，建立从程序模块的特征表示到软件缺陷的映射关系，以预测给定程序模块的是否可能包含缺陷。</p>
<p>基于缺陷标注挖掘软件缺陷的一般流程如图 1所示。首先人工对软件源代码进行详细软件测试，获得每个模块的缺陷情况标注。然后，利用软件度量 (software metric)  [8] 技术提取多种与软件模块的缺陷相关的代码级统计指标 ( 如代码长度、代码分支数、代码的圈复杂度等 ) 作为描述软件模块的特征，从而将程序代码转化为一组特征向量。基于特征向量表示的模块及其缺陷情况标注，通过监督学习得到预测模型，对新的模块的缺陷情况进行预测。</p>
<p><a href="https://yqfile.alicdn.com/c61ca2e69b8edeccfbeff6caab5b51eff44fe8a6.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2M2MWNhMmU2OWI4ZWRlY2NmYmVmZjZjYWFiNWI1MWVmZjQ0ZmU4YTYucG5n.jpg"></a></p>
<p>特征与学习算法<br />
基于缺陷标注挖掘软件缺陷的建模过程有两个关键步骤，第一，如何提取适合于预测模块缺陷情况的特征；第二，如何选取合适的学习方法。 在特征提取方面，Menzies et al [9] 提出利用代码的静态特征 ( 包括 LOC ( 代码长度 )、McCabe 复杂度、Halstead 复杂度等 ) 来描述软件模块用于缺陷挖掘。在此基础上，Zimmermann et al [10] 提出了图结构特征。Kim et al [11] 提出了软件时空局部性特征，并基于此预测软件模块的缺陷情况。除设计和使用新的软件度量作为特征以外，还可以基于现有特征构建更有利于进行软件缺陷挖掘的特征[12-13] ，或是从源代码出发直接学习新型特征表示[14] 。</p>
<p>在学习算法的选取方面，研究者们早期对不同的学习算法在软件缺陷挖掘任务上的表现进行了研究，使用的学习算法包括朴素贝叶斯分类器[15] 、逻辑回归[16] 、神经网络 [17]等。Lessmann et al [18] 在11 个基准缺陷预测的数据集 NASA 上，通过大量实验对比了 19 个预测模型方法 (SVM、逻辑回归、决策树、朴素贝叶斯等 )，揭示出没有任何算法在所有数据上都一致优于其他算法，从而也为类似研究画上了句号。</p>
<p>应对昂贵的人工标注<br />
由于软件模块的缺陷标注需要程序员对代码进行详细测试或人工代码检查，会消耗大量软件质量保障资源。对于一个刚完成的开发软件项目通常仅能获得极少量的缺陷标注。利用如此少量的数据进行学习建模，难以获得良好的性能。</p>
<p>为 缓 解昂贵人工缺陷标注导致训练样本不足这一问题，一种思路是利用有较多缺陷标注积累的早期版本或者软件项目来扩充训练数据。然而，由于发现不同项目的代码特征分布相差大，直接进行跨软件项目的缺陷挖掘性能很差[19] 。</p>
<p>针对这一问题，Turhan et al [20] 利用最近邻方法从其他公司的缺陷数据中筛选出与本项目数据分布相似的模块，并利用这些模块来帮助预测当前项目的缺陷，获得了性能的改善；Nam et al [21] 基于迁移学习技术将其他项目的缺陷信息映射到当前软件项目并加以利用，提升了跨项目缺陷预测的性能。</p>
<p>除利用其他项目的历史数据资源外，另一种思路是充分利用待预测的软件模块中蕴涵的分布信息来辅助提升学习性能。Seliya et al [22-23] 最早将半监督学习技术引入软件缺陷挖掘 , 他们使用基于约束的 k- 均值算法来对当前的软件模块数据进行半监督聚类，并据此标注软件模块的缺陷情况；Lu et al [24]使用了一种基于自我训练的半监督分类方法对软件缺陷进行预测，在此基础上，通过对软件模块数据进行降维，从而获得更好的性能[25] 。由于在实际应用中，包含软件缺陷的模块数量往往远少于正常模块数量。Jiang et al [26] 讨论了缺陷模块分布不平衡对学习性能造成的影响，并提出了一种的能够应对数据分布不平衡的半监督学习方法 ROCUS，较直接进行监督学习性能提升超过了 70%。Li et al [27]提出代价敏感半监督软件缺陷预测方法，能够在高风险应用场景中更加有效地识别高风险缺陷。为进一步降低人工标注开销，Li et al [28] 在半监督学习中进一步引入主动学习机制，通过主动挑选出最困难的模块获得人工缺陷标注并加以学习，在有限测试资源投放的情况下获得了尽可能大的性能提升。</p>
<p>面向更多实际问题<br />
在基于缺陷标注的软件缺陷挖掘中，除需要有效应对昂贵人工标注为学习建模带来的困难，还需要考虑其他的各种实际问题，以提升软件缺陷挖掘在实际软件开发中的可用性。Jiang et al [29] 指出不同开发人员的编码习惯和风格会导致缺陷模式各异，因此需要针对不同开发人员构建预测模型，从而获得更优的缺陷预测性能。Tantithamthavorn etal [30] 研究了软件数据所包含噪声对缺陷预测结果的影响。Peters et al [31] 研究了跨项目挖掘中的隐私保护问题，提出了 LACE2 模型减少数据分享带来的隐私泄露隐患。Tan et al [32] 提出了软件缺陷挖掘的评估和建模应该考虑时序关系。</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-18 22:08:21</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/%e6%a8%a1%e5%9d%97/" title="模块">模块</a>, <a href="https://www.iamivan.net/tag/%e6%80%a7%e8%83%bd/" title="性能">性能</a>, <a href="https://www.iamivan.net/tag/%e4%ba%ba%e5%b7%a5%e6%99%ba%e8%83%bd/" title="人工智能">人工智能</a>, <a href="https://www.iamivan.net/tag/%e7%ae%97%e6%b3%95/" title="算法">算法</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>《中国人工智能学会通讯》——8.43 基于缺陷标注挖掘软件缺陷的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/p5ZE2Bz.html" rel="bookmark">中国人工智能学会通讯&mdash;&mdash;一种基于众包的交互式数据修复方法   5 相关工作</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				5 相关工作 数据修复旨在发现和修正数据库中错误的数据.在过去的几十年里,研究人员提出了各种各样自动发现并修复数据库中错误数据的方法[1].这些方法大致可以分为如下三类. (1)传统的方法先依赖各种约束条件,包括FDs[5,7].CFDs[6].完整性约束[4]和包含关系(INCs)[5]来检测数据中的由错误数据引起的不一致性(或冲突):然后用文献[2-4]中的方法修正所有的错误数据,从而解决所有的冲突.对一般的文本数据库,这一类方法中的大部分工作都是使用FD/CFDs进行修复,因为FD/CFD			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/ze061Np.html" rel="bookmark">《中国人工智能学会通讯》&mdash;&mdash;12&period;6 增量序列模式挖掘</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				12.6 增量序列模式挖掘 在动态更新的流式数据中进行数据挖掘的需求由来已久[34] ,对于序列模式挖掘来说,当数据发生少量更新时对全体数据重新进行挖掘是不可取的.因此,一些增量序列挖掘算法被提出以适应不断增长的数据,这类算法在更新迅速的大数据中显得十分重要. Parthasarathy 等人[35]提出的 ISM 增量序列模式挖掘算法,基于 SPADE 算法进行扩展,以最小的 I/O 和计算代价处理新增数据.具体地,一种增量序列晶格的结构被用于存储所有频繁序列 , 以及原数据库中位于负边界中的			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MlAlwap.html" rel="bookmark">《中国人工智能学会通讯》&mdash;&mdash;12&period;5 并行序列模式挖掘</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				12.5 并行序列模式挖掘 早期的并行序列模式挖掘算法大多被用于解决算法效率低下的问题.因此,许多并行算法是由其串行版本改进得到.例如,Zaki [28] 扩展了由他自己提出的 SPADE 算法,提出了在内存共享框架下的并行算法 pSPADE.pSPADE 的并行性主要来源于对垂直格式数据库的划分,这种划分既可以横向也可以纵向,最终实现了并行.采用了相似策略的算法还有 Par-ASP [29] 和 Par-CSP [30] 等. 近年来,随着数据量的不断增大.数据类型的不断变化,以及新型并行计算			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/z44nRjz.html" rel="bookmark">《中国人工智能学会通讯》&mdash;&mdash;8&period;41 软件缺陷挖掘</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				8.41 软件缺陷挖掘 软件是计算机系统的灵魂,软件的质量是计算机系统安全可靠运行的保障.伴随着软件运行环境逐渐从封闭.静态的单机环境向开放.动态多变的网络环境过渡,系统功能变得越发复杂,代码规模也不断增加,如何有效保证庞大而复杂的软件系统的质量使其能够正确.可靠的运行,已成为软件研究者和软件开发人员所面临的巨大挑战. 软件质量主要体现为软件的可靠性.可用性.有效性和可维护性[1] ,其中软件的可靠性尤为重要.导致软件系统不可靠的主要诱因之一是软件缺陷[2] .软件缺陷是软件中存在的某种破坏其正			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MgwDD3M.html" rel="bookmark">《中国人工智能学会通讯》&mdash;&mdash;8&period;44 基于用户缺陷报告挖掘软件缺陷</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				8.44 基于用户缺陷报告挖掘软件缺陷 缺陷报告是用户向软件开发者汇报软件使用过程中所遇故障的报告.该报告基于自然语言书写,记录了软件发生故障场景和症状等信息.通过分析软件缺陷报告,可以有效定位出导致该缺陷的程序代码,从而帮助程序员对其进行修复. 由于缺陷报告是终端用户通过自然语言书写,因此基于用户缺陷报告进行缺陷挖掘的关键在于如何建立缺陷报告与符合其功能描述的代码之间的联系.现有技术通常将程序代码视为自然语言,然后基于文本空间建立缺陷报告与程序代码之间的相关性,从而发现缺陷代码.向量空间模型			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bj8XaWp.html" rel="bookmark">《中国人工智能学会通讯》&mdash;&mdash;8&period;42 基于编程模式挖掘软件缺陷</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				8.42 基于编程模式挖掘软件缺陷 软件缺陷种类繁多且新缺陷不断出现.不同缺陷形成的原因各不相同.试图通过直接描述软件缺陷模式来发现软件缺陷非常困难.所幸,由于程序编写过程需要遵循程序设计语言确立的各种编程规范和约定,无缺陷的正常程序大都应与此&quot;正常模式&quot;相符.因此,要挖掘软件缺陷,可以设法对正常程序需要符合与遵循的编程模式进行建模,据此发现与此&quot;正常模式&quot;相违背的潜在软件缺陷.对编程模式的刻画,可通过对软件项目中的源代码以及其他相关非代码数据的分析和挖掘来实现.			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/Mxoj90b.html" rel="bookmark">中国人工智能学会通讯&mdash;&mdash;机器学习里的贝叶斯基本理论、模型和算法</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				非常感 谢周老师给这个机会让我跟大家分享一下.我今天想和大家分享的是,在深度学习或者大数据环境下我们怎么去看待相对来说比较传统的一类方法--贝叶斯方法.它是在机器学习和人工智能里比较经典的方法. 类似的报告我之前在CCF ADL讲过,包括去年暑假周老师做学术主任在广州有过一次报告,大家如果想看相关的工作,我们写了一篇文章,正好我今天讲的大部分思想在这个文章里面有一个更系统的讲述,大家可以下去找这篇文章读. 这次分享主要包括三个部分: 第一部分:基本理论.模型和算法 贝叶斯方法基础 正则化贝叶斯推			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zwx8Lnb.html" rel="bookmark">中国人工智能学会通讯&mdash;&mdash;无智能，不驾驶&mdash;&mdash;面向未来的智能驾驶时代 &lpar; 下 &rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				到目前为止似乎比较完美,而实际还 存在着一些问题.我们现在看到很多道 路上面,交通标志牌它的分布非常稀疏, 可能每过一两公里才能够检测出来一个 交通标志牌,因为毕竟这个深度学习算 法是目前最完美的,它有时候还会错过 一个交通标志牌,这时候怎么办呢?我 们会发现在路面上也有非常明显的视觉 特征,我只要把路面的这些视觉特征识 别出来进行匹配,其实是有连续的绝对 的视觉参考的.所以我们做的办法是, 把这个路面粘贴起来.这个粘贴的方法 很简单,跟我们手机拍场景图片一样, 我们慢慢移动的时候可以把这个场景			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bQBj0rM.html" rel="bookmark">中国人工智能学会通讯&mdash;&mdash;深蓝、沃森与AlphaGo</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在 2016 年 3 月 份,正当李 世石与AlphaGo 进行人机大战的时候,我曾经写过 一 篇&lt; 人 工 智 能 的 里 程 碑: 从 深 蓝 到AlphaGo&gt;,自从 1997 年深蓝战胜卡斯帕罗夫之后,随着计算机硬件水平的提高,计算机象棋(包括国际象棋和中国象棋)水平有了很大的提高,达到了可以战胜人类最高棋手的水平.但是,长期以来,在计算机围棋上进展却十分缓慢,在 2006 年引入了蒙特卡洛树搜索方法之后,也只能达到业余 5 段的水平.所以 AlphaGo 战胜韩国棋手李世石,确实是人			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/xp8VgNb.html" rel="bookmark" class="title">C&num;过滤器HttpModule</a>
					<div>
						C#过滤器HttpModule的使用,如下代码示例: using System;  using System.Web;    public class HttpModule:IHttpModule   ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/gpkE0rb.html" rel="bookmark" class="title">制作虚拟主机管理系统（一）</a>
					<div>
						虚拟主机|虚拟主机 前言 公司有两台服务器空着--没什么作用,打算明年拿来做虚拟主机业务.网上找了一些虚拟主机的管理系统,没什么用,基本上都是数据库操作,很少有对FTP.IIS.MAIL操作的考虑了半 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/OMy8AEb.html" rel="bookmark" class="title">新站排名如何超越老站？</a>
					<div>
						如何在某一个行业做一名后起之秀?仿佛不那么简单,但至少我们拥有的是年轻.笔者的新站SEO之路上线已有一周,还没有受到搜索引擎的特别关照,尽管我是原创的内容,尽管我是简单的程序.但就在这一个起点,我就开 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/lpP5EAz.html" rel="bookmark" class="title">使用servlet和jsp上载文件</a>
					<div>
						js|servlet Use JSP and Servlet to Upload file to server is becoming a common task now. Below is a si ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/dzZ9Gkp.html" rel="bookmark" class="title">在ASP中使用CDO发送邮件</a>
					<div>
						在ASP中使用CDO发送邮件   在ASP(Active Server Pages)中发送邮件不是件困难的事情,需要的条件就是使用CDO组件(Collaborative Data Object),它是 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MNEQLxb.html" rel="bookmark" class="title">通过Python脚本理解系统进程间通信</a>
					<div>
						from socket import *  #导入socket包中的所有内容 from time import ctime #导入time包,同时在本地可使用ctime进行调用 import os,s ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bEl9Nnz.html" rel="bookmark" class="title">如何使用手机wps查看ppt演示文稿缩略图</a>
					<div>
						  使用手机wps查看ppt演示文稿缩略图的方法: 首先打开手机WPS Office 打开PPT 需要演搞左上角显示&quot;编辑&quot;两个字,这个时候就是没有编辑的状态 点击&quot;工具 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M91KxXM.html" rel="bookmark" class="title">win7无法开机显示0xc000000e怎么解决</a>
					<div>
						win7无法开机显示0xc000000e怎么解决   解决方法: 这种情况下,大家可以进入大番薯pe,然后调出命令提示符,执行下述5条dos命令: c: cd windowssystem32 bcde ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mq8eJYb.html" rel="bookmark" class="title">Windows&period;old文件夹删除不了怎么办</a>
					<div>
						  WINDOWS.OLD文件夹是Win7对以前的旧版系统所做的备份.因为其特殊性,用户不能直接删除该文件夹.在直接删除的时候常常会出现&quot;找不到该项目&quot;的错误,导致Windows  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bjmOl0z.html" rel="bookmark" class="title">BP神经网络算法</a>
					<div>
						今天来讲BP神经网络,神经网络在机器学习中应用比较广泛,比如函数逼近,模式识别,分类,数据压缩,数据挖掘等领域.接下来介绍BP神经网络的原理及实现. Contents 1. BP神经网络的认识 2.  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQr2O0M.html" rel="bookmark" class="title">ios-想问下，iOS tableviewcell 高度如何跟文字内容高度一样呢？</a>
					<div>
						问题描述 想问下,iOS tableviewcell 高度如何跟文字内容高度一样呢? 想问下,iOS tableviewcell 高度如何跟文字内容高度一样呢? 它自己根据里面的文字或者图片自定义高度 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M9Yw2VM.html" rel="bookmark" class="title">在Google Play引入付费搜索结果</a>
					<div>
						摘要: Google仍然是搜索市场当之无愧的龙头.它的那些Google Glass.无人汽车.风力发电.无人机Project Wing,Project Loon,喷气背包.悬浮滑板等未来计划依旧很酷, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/boKLWBb.html" rel="bookmark" class="title">导入旧版本Android项目时的&OpenCurlyDoubleQuote;Unable to resolve target &OpenCurlyQuote;android</a>
					<div>
						在Ecplise + ATD + Android SDK的开发中,导入旧版本的Android项目时,往往会出现类似的如下错误 Error:Unable to resolve target 'andro ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlKVKOb.html" rel="bookmark" class="title">android编写Service入门用法与教程</a>
					<div>
						http://4225953-163-com.iteye.com/blog/792997					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPB2Q0b.html" rel="bookmark" class="title">ERROR 1044 &lpar;42000&rpar;&colon; Access denied for user &amp;&num;039&semi;&amp;&num;039&semi;&commat;&amp;&num;039&semi;localhost&amp;&num;039&semi; to database &amp;&num;039&semi;mysql&amp;&num;039&semi;</a>
					<div>
						在centos下安装好了mysql,用root帐号连上mysql,然后创建一个数据库,提示下图错误: 提示:ERROR 1044 (42000): Access denied for user ''@ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mvm6EVb.html" rel="bookmark" class="title">ios 支付宝网页支付  总是显示参数错误是怎莫回事</a>
					<div>
						问题描述 ios 支付宝网页支付 总是显示参数错误是怎莫回事 partner=&quot;2088811116320160&quot;&amp;seller_id=&quot;jms@jimaison ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b3JJ1Jz.html" rel="bookmark" class="title">这里有一份面筋请查收（四）</a>
					<div>
						这里我连续介绍三家公司的面试,一家是只有一面,还有两家是面完一面就没去了,没去主要是当时一周面了6家而且是在不同的城市,就选择性的挑了这两家没去,是在是太累了,6月17日那天嗓子都面哑了. 第一家(2 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8YdEBz.html" rel="bookmark" class="title">有时候我在开会，也有人在下边玩手机游戏</a>
					<div>
						我知道年轻人爱打游戏,有时候我在开会,也有人在下边玩手机游戏.打游戏不是一件坏事,但是我认为一个人应该要把握住自己,不要让娱乐过度的毁坏我们的生活和工作.反而要像主动升级打怪那样,对自己的工作和学习, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5RXKWz.html" rel="bookmark" class="title">什么是流量劫持，如何防止流量劫持？</a>
					<div>
						流量劫持,是利用各种恶意软件修改浏览器.锁定主页或不停弹出新窗口,强制用户访问某些网站,从而造成用户流量损失的情形.流量劫持是一种古老的攻击方式,比如早已见惯的广告弹窗(如下图)等,很多人已经对此麻木 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pLgW1WM.html" rel="bookmark" class="title">谷歌使用微软的技术提高 Chrome 15％的速度</a>
					<div>
						速度是Google在面对来自Microsoft的Windows 10 Edge浏览器的竞争时,让Chrome更适合Windows用户的一种方式. Chrome最近致力于让Chrome速度更快,Goog ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zGZqK2p.html" rel="bookmark" class="title">Changing Tint &sol; Background color of UITabBar</a>
					<div>
						28 down vote favorite 46 share [fb] share [tw] The UINavigationBar and UISearchBar both have a tintC ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MR1Nwqb.html" rel="bookmark" class="title">浅析Ruby中的类对象的概念&lowbar;ruby专题</a>
					<div>
						 面向对象的程序涉及类和对象. 一个类是蓝本,从个别对象被创建.在面向对象的术语,我们说小明的自行车是被称为自行车类的对象实例. 任何车辆的例子.它包括轮子,马力,燃油或燃气罐容量.这些特点形成的类车 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pL5XXRz.html" rel="bookmark" class="title">Java中的代理原理及代理使用示例&lowbar;java</a>
					<div>
						今天再测试Socket编程时,无法连接外网.公司用的是Http的代理.上网搜索也没看太懂,所以花了大量时间来学习.看了HTTP和TCP协议的关系好,才有所明白.现在能通过Socket使用HTTP代理了 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5QXqDp.html" rel="bookmark" class="title">网站成功之道之 坚持、坚持、再坚持</a>
					<div>
						一.成功不外乎&quot;坚持.坚持.再坚持&quot;.相对于专业站长,我什么也不会了,长时间一来,一直在摸索中学习,在学习中摸索.给我最深感受的是,无论网站有没有流量,无论百度能不能找到我的网站, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bKqB6Op.html" rel="bookmark" class="title">64位win7下pl&sol;sql无法连接oracle解决方法&lowbar;oracle</a>
					<div>
						1.pl/sql无法连接本机的oracle(ORA 12154:TNS:无法解析指定的连接标识符) 解决方法:pl/sql不能安装在Program Files(x86)文件夹下,要安装在Program ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MyWDo5z.html" rel="bookmark" class="title">JSP如何实现&comma;根据数据库内容验证登录信息是否存在</a>
					<div>
						问题描述 &lt;form action=&quot;${ctx }/add/addBlock.do&quot; name=&quot;addBlock&quot; method=&quot;post ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pXdw0Kp.html" rel="bookmark" class="title">世界首款雷电接口超便携双硬盘My Passport Pro发布</a>
					<div>
						[TechWeb报道]4月1日消息,西部数据今天发布了最新超便携双硬盘My Passport Pro,即全球首款由雷电接口(Thunderbolt)供电.高性能.大容量.适合创意专业人士与发烧友的真正 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5Yqnnp.html" rel="bookmark" class="title">Testin云测：手游App分发平台内应用宝最佳</a>
					<div>
						硅谷网10月10日讯 随着智能机与3G网络的 快速发展,人类飞奔进入移动互联网时代,移动互联网彻底改变了人们工作生活习惯,工作.休闲娱乐打不部分时间已经转移到移动端,各大手游App分发平台也如雨后春笋 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M9NnOdp.html" rel="bookmark" class="title">Global System of Mobile communication，GSM</a>
					<div>
						Global System of Mobile communication,GSM 即全球移动http://www.aliyun.com/zixun/aggregation/11496.html&qu ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MNm3XJb.html" rel="bookmark" class="title">请问谁有Infragistics NetAdvantage 2008 Vol2&period; WinForms</a>
					<div>
						问题描述 如题,请问谁有InfragisticsNetAdvantage2008Vol2.WinForms就是这个版本,在论坛里.网上找了一个月都没有找到,急死我了啊,唉....无奈 解决方案 解决方 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.024 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
